--- a/lib/html.php
+++ b/lib/html.php
@@ -144,14 +144,15 @@
 					<table align='center' cellpadding='0'>
 						<tr>
 							<td align='center'>
-								<div style="min-height: <?php echo (1.6 * $graph["height"]) . "px"?>;"><a href='<?php print htmlspecialchars("graph.php?action=view&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=all");?>'><img class='graphimage' id='graph_<?php print $graph["local_graph_id"] ?>' src='<?php print htmlspecialchars("graph_image.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0" . (($extra_url_args == "") ? "" : "&$extra_url_args"));?>' border='0' alt='<?php print htmlspecialchars($graph["title_cache"]);?>'></a></div>
+								<div style="min-height: <?php echo (1.6 * $graph["height"]) . "px"?>;"><a href='<?php print htmlspecialchars($config['url_path'] . "graph.php?action=view&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=all");?>'><img class='graphimage' id='graph_<?php print $graph["local_graph_id"] ?>' src='<?php print htmlspecialchars($config['url_path'] . "graph_image.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0" . (($extra_url_args == "") ? "" : "&$extra_url_args"));?>' border='0' alt='<?php print htmlspecialchars($graph["title_cache"]);?>'></a></div>
 								<?php print (read_graph_config_option("show_graph_title") == "on" ? "<p style='font-size: 10;' align='center'><strong>" . htmlspecialchars($graph["title_cache"]) . "</strong></p>" : "");?>
 							</td>
 							<td valign='top' style='align: left; padding: 3px;' class='noprint'>
-								<a href='<?php print htmlspecialchars("graph.php?action=zoom&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&". $extra_url_args);?>'><img src='images/graph_zoom.gif' border='0' alt='Zoom Graph' title='Zoom Graph' style='padding: 3px;'></a><br>
-								<a href='<?php print htmlspecialchars("graph_xport.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
-								<a href='<?php print htmlspecialchars("graph.php?action=properties&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='images/graph_properties.gif' border='0' alt='Graph Source/Properties' title='Graph Source/Properties' style='padding: 3px;'></a><br>
-								<a href='#page_top'><img src='images/graph_page_top.gif' border='0' alt='Page Top' title='Page Top' style='padding: 3px;'></a><br>
+								<a href='<?php print htmlspecialchars($config['url_path'] . "graph.php?action=zoom&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&". $extra_url_args);?>'><img src='<?php print $config['url_path'];?>images/graph_zoom.gif' border='0' alt='Zoom Graph' title='Zoom Graph' style='padding: 3px;'></a><br>
+								<a href='<?php print htmlspecialchars($config['url_path'] . "graph_xport.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='<?php print $config['url_path'];?>images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
+								<a href='<?php print htmlspecialchars($config['url_path'] . "graph.php?action=properties&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='<?php print $config['url_path'];?>images/graph_properties.gif' border='0' alt='Graph Source/Properties' title='Graph Source/Properties' style='padding: 3px;'></a><br>
+								<?php api_plugin_hook('graph_buttons', array('hook' => 'graphs_thumbnails', 'local_graph_id' => $graph['local_graph_id'], 'rra' =>  0, 'view_type' => 'view')); ?>
+								<a href='#page_top'><img src='<?php print $config['url_path']; ?>images/graph_page_top.gif' border='0' alt='Page Top' title='Page Top' style='padding: 3px;'></a><br>
 							</td>
 						</tr>
 					</table>
@@ -177,6 +178,7 @@
    @arg $extra_url_args - extra arguments to append to the url
    @arg $header - html to use as a header */
 function html_graph_thumbnail_area(&$graph_array, $no_graphs_message = "", $extra_url_args = "", $header = "") {
+	global $config;
 	$i = 0; $k = 0; $j = 0;
 
 	$num_graphs = sizeof($graph_array);
@@ -268,14 +270,15 @@
 				<table align='center' cellpadding='0'>
 					<tr>
 						<td align='center'>
-							<div style="min-height: <?php echo (1.6 * read_graph_config_option("default_height")) . "px"?>;"><a href='<?php print htmlspecialchars("graph.php?action=view&rra_id=all&local_graph_id=" . $graph["local_graph_id"]);?>'><img class='graphimage' id='graph_<?php print $graph["local_graph_id"] ?>' src='<?php print htmlspecialchars("graph_image.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&graph_height=" . read_graph_config_option("default_height") . "&graph_width=" . read_graph_config_option("default_width") . "&graph_nolegend=true" . (($extra_url_args == "") ? "" : "&$extra_url_args"));?>' border='0' alt='<?php print htmlspecialchars($graph["title_cache"]);?>'></a></div>
+							<div style="min-height: <?php echo (1.6 * read_graph_config_option("default_height")) . "px"?>;"><a href='<?php print htmlspecialchars($config['url_path'] . "graph.php?action=view&rra_id=all&local_graph_id=" . $graph["local_graph_id"]);?>'><img class='graphimage' id='graph_<?php print $graph["local_graph_id"] ?>' src='<?php print htmlspecialchars($config["url_path"] . "graph_image.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&graph_height=" . read_graph_config_option("default_height") . "&graph_width=" . read_graph_config_option("default_width") . "&graph_nolegend=true" . (($extra_url_args == "") ? "" : "&$extra_url_args"));?>' border='0' alt='<?php print htmlspecialchars($graph["title_cache"]);?>'></a></div>
 							<?php print (read_graph_config_option("show_graph_title") == "on" ? "<p style='font-size: 10;' align='center'><strong>" . htmlspecialchars($graph["title_cache"]) . "</strong></p>" : "");?>
 						</td>
 						<td valign='top' style='align: left; padding: 3px;'>
-							<a href='<?php print htmlspecialchars("graph.php?action=zoom&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='images/graph_zoom.gif' border='0' alt='Zoom Graph' title='Zoom Graph' style='padding: 3px;'></a><br>
-							<a href='<?php print htmlspecialchars("graph_xport.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
-							<a href='<?php print htmlspecialchars("graph.php?action=properties&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='images/graph_properties.gif' border='0' alt='Graph Source/Properties' title='Graph Source/Properties' style='padding: 3px;'></a><br>
-							<a href='#page_top'><img src='images/graph_page_top.gif' border='0' alt='Page Top' title='Page Top' style='padding: 3px;'></a><br>
+							<a href='<?php print htmlspecialchars($config['url_path'] . "graph.php?action=zoom&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='<?php print $config['url_path'];?>images/graph_zoom.gif' border='0' alt='Zoom Graph' title='Zoom Graph' style='padding: 3px;'></a><br>
+							<a href='<?php print htmlspecialchars($config['url_path'] . "graph_xport.php?local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='<?php print $config['url_path'];?>images/graph_query.png' border='0' alt='CSV Export' title='CSV Export' style='padding: 3px;'></a><br>
+							<a href='<?php print htmlspecialchars($config['url_path'] . "graph.php?action=properties&local_graph_id=" . $graph["local_graph_id"] . "&rra_id=0&" . $extra_url_args);?>'><img src='<?php print $config['url_path'];?>images/graph_properties.gif' border='0' alt='Graph Source/Properties' title='Graph Source/Properties' style='padding: 3px;'></a><br>
+							<?php api_plugin_hook('graph_buttons_thumbnails', array('hook' => 'graphs_thumbnails', 'local_graph_id' => $graph['local_graph_id'], 'rra' =>  0, 'view_type' => '')); ?>
+							<a href='#page_top'><img src='<?php print $config['url_path'] . "images/graph_page_top.gif";?>' border='0' alt='Page Top' title='Page Top' style='padding: 3px;'></a><br>
 						</td>
 					</tr>
 				</table>
@@ -638,9 +641,9 @@
 		print "<td style='$this_row_style'>" . $item["hex"] . "</td>\n";
 
 		if ($disable_controls == false) {
-			print "<td><a href='" . htmlspecialchars("$filename?action=item_movedown&id=" . $item["id"] . "&$url_data") . "'><img src='images/move_down.gif' border='0' alt='Move Down'></a>
-					<a href='" . htmlspecialchars("$filename?action=item_moveup&id=" . $item["id"] . "&$url_data") . "'><img src='images/move_up.gif' border='0' alt='Move Up'></a></td>\n";
-			print "<td align='right'><a href='" . htmlspecialchars("$filename?action=item_remove&id=" . $item["id"] . "&$url_data") . "'><img src='images/delete_icon.gif' style='height:10px;width:10px;' border='0' alt='Delete'></a></td>\n";
+			print "<td><a href='" . htmlspecialchars("$filename?action=item_movedown&id=" . $item["id"] . "&$url_data") . "'><img src='" . $config['url_path'] . "images/move_down.gif' border='0' alt='Move Down'></a>
+					<a href='" . htmlspecialchars("$filename?action=item_moveup&id=" . $item["id"] . "&$url_data") . "'><img src='" . $config['url_path'] . "images/move_up.gif' border='0' alt='Move Up'></a></td>\n";
+			print "<td align='right'><a href='" . htmlspecialchars("$filename?action=item_remove&id=" . $item["id"] . "&$url_data") . "'><img src='" . $config['url_path'] . "images/delete_icon.gif' style='height:10px;width:10px;' border='0' alt='Delete'></a></td>\n";
 		}
 
 		print "</tr>";
@@ -706,6 +709,8 @@
 					}
 
 					while (list($item_sub_url, $item_sub_title) = each($item_title)) {
+						$item_sub_url = $config['url_path'] . $item_sub_url;
+
 						/* indent sub-items */
 						if ($i > 0) {
 							$prepend_string = "---&nbsp;";
@@ -715,7 +720,7 @@
 
 						/* do not put a line between each sub-item */
 						if (($i == 0) || ($draw_sub_items == false)) {
-							$background = "images/menu_line.gif";
+							$background = $config['url_path'] . "images/menu_line.gif";
 						}else{
 							$background = "";
 						}
@@ -744,17 +749,18 @@
 			}else{
 				if ($current_realm_id == -1 || (isset($user_realms[$current_realm_id])) || (!isset($user_auth_realm_filenames{basename($item_url)}))) {
 					/* draw normal (non sub-item) menu item */
+					$item_url = $config['url_path'] . $item_url;
 					if (basename($_SERVER["PHP_SELF"]) == basename($item_url)) {
-						print "<tr><td class='textMenuItemSelected' style='background-image:url(\"images/menu_line.gif\");'><strong><a href='" . htmlspecialchars($item_url) . "'>$item_title</a></strong></td></tr>\n";
+						print "<tr><td class='textMenuItemSelected' style='background-image:url(\"" . $config['url_path'] . "images/menu_line.gif\");'><strong><a href='" . htmlspecialchars($item_url) . "'>$item_title</a></strong></td></tr>\n";
 					}else{
-						print "<tr><td class='textMenuItem' style='background-image:url(\"images/menu_line.gif\");'><a href='" . htmlspecialchars($item_url) . "'>$item_title</a></td></tr>\n";
+						print "<tr><td class='textMenuItem' style='background-image:url(\"" . $config['url_path'] . "images/menu_line.gif\");'><a href='" . htmlspecialchars($item_url) . "'>$item_title</a></td></tr>\n";
 					}
 				}
 			}
 		}
 	}
 
-	print "<tr><td class='textMenuItem' style='background-image:url(\"images/menu_line.gif\");'></td></tr>\n";
+	print "<tr><td class='textMenuItem' style='background-image:url(\"" . $config['url_path'] . "images/menu_line.gif\");'></td></tr>\n";
 
 	print "</table></td></tr>";
 }
@@ -764,11 +770,12 @@
    @arg $actions_array - an array that contains a list of possible actions. this array should
      be compatible with the form_dropdown() function */
 function draw_actions_dropdown($actions_array) {
+	global $config;
 	?>
 	<table align='center' width='100%'>
 		<tr>
 			<td width='1' valign='top'>
-				<img src='images/arrow.gif' alt=''>&nbsp;
+				<img src='<?php echo $config['url_path']; ?>images/arrow.gif' alt='' align='middle'>&nbsp;
 			</td>
 			<td align='right'>
 				Choose an action:
--- a/lib/html_form.php
+++ b/lib/html_form.php
@@ -722,11 +722,13 @@
      on a confirmation form
    @arg $cancel_url - the url to go to when the user clicks 'cancel'
    @arg $action_url - the url to go to when the user clicks 'delete' */
-function form_confirm_buttons($action_url, $cancel_url) { ?>
+function form_confirm_buttons($action_url, $cancel_url) {
+	global $config;
+	?>
 	<tr>
 		<td bgcolor="#E1E1E1">
-			<input type='button' onClick='cactiReturnTo("<?php print $cancel_url;?>")' value='Cancel'>
-			<input type='submit' onClick='cactiReturnTo("<?php print $action_url;?>&confirm=true")' value='Delete'>
+			<input type='button' onClick='cactiReturnTo("<?php print $config['url_path'] . $cancel_url;?>")' value='Cancel'>
+			<input type='submit' onClick='cactiReturnTo("<?php print $config['url_path'] . $action_url;?>&confirm=true")' value='Delete'>
 		</td>
 	</tr>
 <?php }
--- /dev/null
+++ b/lib/plugins.php
@@ -0,0 +1,476 @@
+<?php
+
+
+
+function do_hook ($name) {
+	$data = func_get_args();
+	$data = api_plugin_hook ($name, $data);
+	return $data;
+}
+
+function do_hook_function($name,$parm=NULL) {
+	return api_plugin_hook_function ($name, $parm);
+}
+
+function api_user_realm_auth ($filename = '') {
+	return api_plugin_user_realm_auth ($filename);
+}
+
+/**
+ * This function executes a hook.
+ * @param string $name Name of hook to fire
+ * @return mixed $data
+ */
+function api_plugin_hook ($name) {
+	global $config, $plugin_hooks, $plugins_system;
+	$data = func_get_args();
+	$ret = '';
+	$p = array();
+
+	$ps_where = '';
+	if (sizeof($plugins_system)) {
+		foreach($plugins_system as $plugin) {
+			$ps_where .= (strlen($ps_where) ? "', '":"('") . $plugin;
+		}
+		$ps_where .= "')";
+	}
+
+	/* order the plugin functions by system first, then followed by order */
+	$result = db_fetch_assoc("SELECT 1 AS id, ph.name, ph.file, ph.function
+		FROM plugin_hooks AS ph
+		LEFT JOIN plugin_config AS pc
+		ON pc.directory=ph.name
+		WHERE ph.status = 1 AND hook = '$name'
+		AND ph.name IN $ps_where
+		UNION
+		SELECT pc.id, ph.name, ph.file, ph.function
+		FROM plugin_hooks AS ph
+		LEFT JOIN plugin_config AS pc
+		ON pc.directory=ph.name
+		WHERE ph.status = 1 AND hook = '$name'
+		AND ph.name NOT IN $ps_where
+		ORDER BY id ASC", true);
+
+	if (count($result)) {
+		foreach ($result as $hdata) {
+			$p[] = $hdata['name'];
+			if (file_exists($config['base_path'] . '/plugins/' . $hdata['name'] . '/' . $hdata['file'])) {
+				include_once($config['base_path'] . '/plugins/' . $hdata['name'] . '/' . $hdata['file']);
+			}
+			$function = $hdata['function'];
+			if (function_exists($function)) {
+				$function($data);
+			}
+		}
+	}
+
+	if (isset($plugin_hooks[$name]) && is_array($plugin_hooks[$name])) {
+		foreach ($plugin_hooks[$name] as $pname => $function) {
+			if (function_exists($function)  && !function_exists('plugin_' . $pname . '_install') && !in_array($pname, $p)) {
+				$function($data);
+			}
+		}
+	}
+
+	/* Variable-length argument lists have a slight problem when */
+	/* passing values by reference. Pity. This is a workaround.  */
+	return $data;
+}
+
+function api_plugin_hook_function ($name, $parm=NULL) {
+	global $config, $plugin_hooks, $plugins_system;
+	$ret = $parm;
+	$p = array();
+	$ps_where = '';
+
+	if (sizeof($plugins_system)) {
+		foreach($plugins_system as $plugin) {
+			$ps_where .= (strlen($ps_where) ? "', '":"('") . $plugin;
+		}
+		$ps_where .= "')";
+	}
+
+	/* order the plugin functions by system first, then followed by order */
+	$result = db_fetch_assoc("SELECT 1 AS id, ph.name, ph.file, ph.function
+		FROM plugin_hooks AS ph
+		LEFT JOIN plugin_config AS pc
+		ON pc.directory=ph.name
+		WHERE ph.status = 1 AND hook = '$name'
+		AND ph.name IN $ps_where
+		UNION
+		SELECT pc.id, ph.name, ph.file, ph.function
+		FROM plugin_hooks AS ph
+		LEFT JOIN plugin_config AS pc
+		ON pc.directory=ph.name
+		WHERE ph.status = 1 AND hook = '$name'
+		AND ph.name NOT IN $ps_where
+		ORDER BY id ASC", true);
+
+	if (count($result)) {
+		foreach ($result as $hdata) {
+			$p[] = $hdata['name'];
+			if (file_exists($config['base_path'] . '/plugins/' . $hdata['name'] . '/' . $hdata['file'])) {
+				include_once($config['base_path'] . '/plugins/' . $hdata['name'] . '/' . $hdata['file']);
+			}
+			$function = $hdata['function'];
+			if (function_exists($function)) {
+				$ret = $function($ret);
+			}
+		}
+	}
+
+	if (isset($plugin_hooks[$name]) && is_array($plugin_hooks[$name])) {
+		foreach ($plugin_hooks[$name] as $pname => $function) {
+			if (function_exists($function)  && !function_exists('plugin_' . $pname . '_install') && !in_array($pname, $p)) {
+				$ret = $function($ret);
+			}
+		}
+	}
+
+	/* Variable-length argument lists have a slight problem when */
+	/* passing values by reference. Pity. This is a workaround.  */
+	return $ret;
+}
+
+function api_plugin_db_table_create ($plugin, $table, $data) {
+	global $config, $database_default;
+	include_once($config["library_path"] . "/database.php");
+
+	$result = db_fetch_assoc("show tables from `" . $database_default . "`") or die (mysql_error());
+	$tables = array();
+	foreach($result as $index => $arr) {
+		foreach ($arr as $t) {
+			$tables[] = $t;
+		}
+	}
+	if (!in_array($table, $tables)) {
+		$c = 0;
+		$sql = 'CREATE TABLE `' . $table . "` (\n";
+		foreach ($data['columns'] as $column) {
+			if (isset($column['name'])) {
+				if ($c > 0)
+					$sql .= ",\n";
+				$sql .= '`' . $column['name'] . '`';
+				if (isset($column['type']))
+					$sql .= ' ' . $column['type'];
+				if (isset($column['unsigned']))
+					$sql .= ' unsigned';
+				if (isset($column['NULL']) && $column['NULL'] == false)
+					$sql .= ' NOT NULL';
+				if (isset($column['NULL']) && $column['NULL'] == true && !isset($column['default']))
+					$sql .= ' default NULL';
+				if (isset($column['default']))
+					$sql .= ' default ' . (is_numeric($column['default']) ? $column['default'] : "'" . $column['default'] . "'");
+				if (isset($column['auto_increment']))
+					$sql .= ' auto_increment';
+				$c++;
+			}
+		}
+
+		if (isset($data['primary'])) {
+			$sql .= ",\n PRIMARY KEY (`" . $data['primary'] . '`)';
+		}
+
+		foreach ($data['keys'] as $key) {
+			if (isset($key['name'])) {
+				$sql .= ",\n KEY `" . $key['name'] . '` (`' . $key['columns'] . '`)';
+			}
+		}
+		$sql .= ') TYPE = ' . $data['type'];
+
+		if (isset($data['comment'])) {
+			$sql .= " COMMENT = '" . $data['comment'] . "'";
+		}
+		if (db_execute($sql)) {
+			db_execute("INSERT INTO plugin_db_changes (plugin, `table`, method) VALUES ('$plugin', '$table', 'create')");
+		}
+	} else {
+		db_execute("INSERT INTO plugin_db_changes (plugin, `table`, method) VALUES ('$plugin', '$table', 'create')");
+	}
+}
+
+function api_plugin_db_changes_remove ($plugin) {
+	// Example: api_plugin_db_changes_remove ('thold');
+
+	$tables = db_fetch_assoc("SELECT `table` FROM plugin_db_changes WHERE plugin = '$plugin' AND method ='create'", false);
+	if (count($tables)) {
+		foreach ($tables as $table) {
+			db_execute("DROP TABLE IF EXISTS `" . $table['table'] . "`;");
+		}
+		db_execute("DELETE FROM plugin_db_changes where plugin = '$plugin' AND method ='create'", false);
+	}
+	$columns = db_fetch_assoc("SELECT `table`, `column` FROM plugin_db_changes WHERE plugin = '$plugin' AND method ='addcolumn'", false);
+	if (count($columns)) {
+		foreach ($columns as $column) {
+			db_execute('ALTER TABLE `' . $column['table'] . '` DROP `' . $column['column'] . '`');
+		}
+		db_execute("DELETE FROM plugin_db_changes where plugin = '$plugin' AND method = 'addcolumn'", false);
+	}
+}
+
+function api_plugin_db_add_column ($plugin, $table, $column) {
+	// Example: api_plugin_db_add_column ('thold', 'plugin_config', array('name' => 'test' . rand(1, 200), 'type' => 'varchar (255)', 'NULL' => false));
+
+	global $config, $database_default;
+	include_once($config['library_path'] . '/database.php');
+
+	$result = db_fetch_assoc('show columns from `' . $table . '`') or die (mysql_error());
+	$columns = array();
+	foreach($result as $index => $arr) {
+		foreach ($arr as $t) {
+			$columns[] = $t;
+		}
+	}
+	if (isset($column['name']) && !in_array($column['name'], $columns)) {
+		$sql = 'ALTER TABLE `' . $table . '` ADD `' . $column['name'] . '`';
+		if (isset($column['type']))
+			$sql .= ' ' . $column['type'];
+		if (isset($column['unsigned']))
+			$sql .= ' unsigned';
+		if (isset($column['NULL']) && $column['NULL'] == false)
+			$sql .= ' NOT NULL';
+		if (isset($column['NULL']) && $column['NULL'] == true && !isset($column['default']))
+			$sql .= ' default NULL';
+		if (isset($column['default']))
+			$sql .= ' default ' . (is_numeric($column['default']) ? $column['default'] : "'" . $column['default'] . "'");
+		if (isset($column['auto_increment']))
+			$sql .= ' auto_increment';
+		if (isset($column['after']))
+			$sql .= ' AFTER ' . $column['after'];
+
+		if (db_execute($sql)) {
+			db_execute("INSERT INTO plugin_db_changes (plugin, `table`, `column`, `method`) VALUES ('$plugin', '$table', '" . $column['name'] . "', 'addcolumn')");
+		}
+	}
+}
+
+function api_plugin_install ($plugin) {
+	global $config;
+	include_once($config['base_path'] . "/plugins/$plugin/setup.php");
+
+	$exists = db_fetch_assoc("SELECT id FROM plugin_config WHERE directory = '$plugin'", false);
+	if (sizeof($exists)) {
+		db_execute("DELETE FROM plugin_config WHERE directory = '$plugin'");
+	}
+
+	$name = $author = $webpage = $version = '';
+	$function = 'plugin_' . $plugin . '_version';
+	if (function_exists($function)){
+		$info = $function();
+		$name = $info['longname'];
+		if (isset($info['homepage'])) {
+			$webpage = $info['homepage'];
+		}elseif (isset($info['webpage'])) {
+			$webpage = $info['webpage'];
+		}else{
+			$webpage = "Not Stated";
+		}
+		$author = $info['author'];
+		$version = $info['version'];
+	}
+
+	db_execute("INSERT INTO plugin_config (directory, name, author, webpage, version) VALUES ('$plugin', '$name', '$author', '$webpage', '$version')");
+
+	$function = 'plugin_' . $plugin . '_install';
+	if (function_exists($function)){
+		$function();
+		$ready = api_plugin_check_config ($plugin);
+		if ($ready) {
+			// Set the plugin as "disabled" so it can go live
+			db_execute("UPDATE plugin_config SET status = 4 WHERE directory = '$plugin'");
+		} else {
+			// Set the plugin as "needs configuration"
+			db_execute("UPDATE plugin_config SET status = 2 WHERE directory = '$plugin'");
+		}
+	}
+}
+
+function api_plugin_uninstall ($plugin) {
+	global $config;
+	include_once($config['base_path'] . "/plugins/$plugin/setup.php");
+	// Run the Plugin's Uninstall Function first
+	$function = 'plugin_' . $plugin . '_uninstall';
+	if (function_exists($function)) {
+		$function();
+	}
+	api_plugin_remove_hooks ($plugin);
+	api_plugin_remove_realms ($plugin);
+	db_execute("DELETE FROM plugin_config WHERE directory = '$plugin'");
+	api_plugin_db_changes_remove ($plugin);
+}
+
+function api_plugin_check_config ($plugin) {
+	global $config;
+	include_once($config['base_path'] . "/plugins/$plugin/setup.php");
+	$function = 'plugin_' . $plugin . '_check_config';
+	if (function_exists($function)) {
+		return $function();
+	}
+	return TRUE;
+}
+
+function api_plugin_enable ($plugin) {
+	$ready = api_plugin_check_config ($plugin);
+	if ($ready) {
+		api_plugin_enable_hooks ($plugin);
+		db_execute("UPDATE plugin_config SET status = 1 WHERE directory = '$plugin'");
+	}
+}
+
+function api_plugin_is_enabled ($plugin) {
+	$status = db_fetch_cell("SELECT status FROM plugin_config WHERE directory = '$plugin'", false);
+	if ($status == '1')
+		return true;
+	return false;
+}
+
+function api_plugin_disable ($plugin) {
+	api_plugin_disable_hooks ($plugin);
+	db_execute("UPDATE plugin_config SET status = 4 WHERE directory = '$plugin'");
+}
+
+function api_plugin_moveup($plugin) {
+	global $plugins_system;
+
+	$sql_where = "";
+	if (sizeof($plugins_system)) {
+		foreach($plugins_system as $s) {
+			$sql_where .= (strlen($sql_where) ? " AND ":"(") . " directory!='$s'";
+		}
+
+		$sql_where .= ")";
+	}
+
+	$id = db_fetch_cell("SELECT id FROM plugin_config WHERE directory='$plugin'" . (strlen($sql_where) ? " AND " . $sql_where:""));
+	$temp_id = db_fetch_cell("SELECT MAX(id) FROM plugin_config")+1;
+	$prior_id = db_fetch_cell("SELECT MAX(id) FROM plugin_config WHERE id<$id" . (strlen($sql_where) ? " AND " . $sql_where:""));
+
+	/* update the above plugin to the prior temp id */
+	db_execute("UPDATE plugin_config SET id=$temp_id WHERE id=$prior_id");
+	db_execute("UPDATE plugin_config SET id=$prior_id WHERE id=$id");
+	db_execute("UPDATE plugin_config SET id=$id WHERE id=$temp_id");
+}
+
+function api_plugin_movedown($plugin) {
+	global $plugins_system;
+
+	$sql_where = "";
+	if (sizeof($plugins_system)) {
+		foreach($plugins_system as $s) {
+			$sql_where .= (strlen($sql_where) ? " AND ":"(") . " directory!='$s'";
+		}
+
+		$sql_where .= ")";
+	}
+
+	$id = db_fetch_cell("SELECT id FROM plugin_config WHERE directory='$plugin'" . (strlen($sql_where) ? " AND " . $sql_where:""));
+	$temp_id = db_fetch_cell("SELECT MAX(id) FROM plugin_config")+1;
+	$next_id = db_fetch_cell("SELECT MIN(id) FROM plugin_config WHERE id>$id" . (strlen($sql_where) ? " AND " . $sql_where:""));
+
+	/* update the above plugin to the prior temp id */
+	db_execute("UPDATE plugin_config SET id=$temp_id WHERE id=$next_id");
+	db_execute("UPDATE plugin_config SET id=$next_id WHERE id=$id");
+	db_execute("UPDATE plugin_config SET id=$id WHERE id=$temp_id");
+}
+
+function api_plugin_register_hook ($plugin, $hook, $function, $file) {
+	$exists = db_fetch_assoc("SELECT id FROM plugin_hooks WHERE name = '$plugin' AND hook = '$hook'", false);
+	if (!count($exists)) {
+		$settings = array('config_settings', 'config_arrays', 'config_form');
+		if (!in_array($hook, $settings)) {
+			db_execute("INSERT INTO plugin_hooks (name, hook, function, file) VALUES ('$plugin', '$hook', '$function', '$file')");
+		} else {
+			db_execute("INSERT INTO plugin_hooks (name, hook, function, file, status) VALUES ('$plugin', '$hook', '$function', '$file', 1)");
+		}
+	}
+}
+
+function api_plugin_remove_hooks ($plugin) {
+	db_execute("DELETE FROM plugin_hooks WHERE name = '$plugin'");
+}
+
+function api_plugin_enable_hooks ($plugin) {
+	db_execute("UPDATE plugin_hooks SET status = 1 WHERE name = '$plugin'");
+}
+
+function api_plugin_disable_hooks ($plugin) {
+	db_execute("UPDATE plugin_hooks SET status = 0 WHERE name = '$plugin' AND hook != 'config_settings' AND hook != 'config_arrays' AND hook != 'config_form'");
+}
+
+function api_plugin_register_realm ($plugin, $file, $display, $admin = false) {
+	$exists = db_fetch_assoc("SELECT id FROM plugin_realms WHERE plugin = '$plugin' AND file = '$file'", false);
+	if (!count($exists)) {
+		db_execute("INSERT INTO plugin_realms (plugin, file, display) VALUES ('$plugin', '$file', '$display')");
+		if ($admin) {
+			$realm_id = db_fetch_assoc("SELECT id FROM plugin_realms WHERE plugin = '$plugin' AND file = '$file'", false);
+			$realm_id = $realm_id[0]['id'] + 100;
+			$user_id = db_fetch_assoc("SELECT id FROM user_auth WHERE username = 'admin'", false);
+			if (count($user_id)) {
+				$user_id = $user_id[0]['id'];
+				$exists = db_fetch_assoc("SELECT realm_id FROM user_auth_realm WHERE user_id = $user_id and realm_id = $realm_id", false);
+				if (!count($exists)) {
+					db_execute("INSERT INTO user_auth_realm (user_id, realm_id) VALUES ($user_id, $realm_id)");
+				}
+			}
+		}
+	}
+}
+
+function api_plugin_remove_realms ($plugin) {
+	$realms = db_fetch_assoc("SELECT id FROM plugin_realms WHERE plugin = '$plugin'", false);
+	foreach ($realms as $realm) {
+		$id = $realm['id'] + 100;
+		db_execute("DELETE FROM user_auth_realm WHERE realm_id = '$id'");
+	}
+	db_execute("DELETE FROM plugin_realms WHERE plugin = '$plugin'");
+}
+
+function api_plugin_load_realms () {
+	global $user_auth_realms, $user_auth_realm_filenames;
+	$plugin_realms = db_fetch_assoc("SELECT * FROM plugin_realms ORDER BY plugin, display", false);
+	if (count($plugin_realms)) {
+		foreach ($plugin_realms as $plugin_realm) {
+			$plugin_files = explode(',', $plugin_realm['file']);
+			foreach($plugin_files as $plugin_file) {
+				$user_auth_realm_filenames[$plugin_file] = $plugin_realm['id'] + 100;
+			}
+			$user_auth_realms[$plugin_realm['id'] + 100] = $plugin_realm['display'];
+		}
+	}
+}
+
+function api_plugin_user_realm_auth ($filename = '') {
+	global $user_realms, $user_auth_realms, $user_auth_realm_filenames;
+	/* list all realms that this user has access to */
+	if (!isset($user_realms)) {
+		if (read_config_option('global_auth') == 'on' || read_config_option('auth_method') != 0) {
+			$user_realms = db_fetch_assoc("select realm_id from user_auth_realm where user_id=" . $_SESSION["sess_user_id"], false);
+			$user_realms = array_rekey($user_realms, "realm_id", "realm_id");
+		}else{
+			$user_realms = $user_auth_realms;
+		}
+	}
+	if ($filename != '') {
+		if (isset($user_realms[$user_auth_realm_filenames{basename($filename)}]))
+			return TRUE;
+	}
+	return FALSE;
+}
+
+function plugin_config_arrays () {
+	global $menu;
+	$menu['Configuration']['plugins.php'] = 'Plugin Management';
+	api_plugin_load_realms ();
+}
+
+function plugin_draw_navigation_text ($nav) {
+	$nav["plugins.php:"] = array("title" => "Plugin Management", "mapping" => "index.php:", "url" => "plugins.php", "level" => "1");
+	return $nav;
+}
+
+
+
+
+
+
+
--- a/lib/poller.php
+++ b/lib/poller.php
@@ -344,8 +344,11 @@
 				}
 			}
 		}
+		api_plugin_hook_function('poller_output', $rrd_update_array);
 
-		$rrds_processed = rrdtool_function_update($rrd_update_array, $rrdtool_pipe);
+		if (api_plugin_hook_function('poller_on_demand', $results)) {
+			$rrds_processed = rrdtool_function_update($rrd_update_array, $rrdtool_pipe);
+		}
 	}
 
 	return $rrds_processed;
